#include <string.h>
#include <stdlib.h>
#include "dict.h"

extern void yyerror(char*);

/*
 * Repraesentiert einen Eintrag im Dictonary
 * @field	name	Name der Variablen
 * @field	value	Wert der Variablen
 * @field	next	Zeiger auf das naechste Element
 */
typedef struct Entry {
	char* 	name;
	double	value;
	struct Entry *next;
} Entry;

/* das Dictionary */
Entry* dict = NULL;


double lookup(char *name) {
	Entry *tmp;
	for (tmp = dict; tmp && (strcmp(tmp->name, name) != 0); tmp = tmp->next);
	
	if (!tmp) {
		yyerror("Variable nicht gefunden\n");
	}
	
	return tmp->value;
}

void insert(char *name, double value) {
	Entry *newVal, *tmp = NULL;
	
	if (!(newVal = malloc(sizeof(Entry)))) {
		yyerror("Kein Speicher alloziierbar\n");
	}
	
	newVal->name  = name;
	newVal->value = value;
	newVal->next  = NULL;
	
	if (!dict) {
		dict = newVal;
		return;
	}

    do {
    	tmp = tmp?tmp->next:dict;
		if (strcmp(tmp->name, name) == 0) {
			tmp->value = value;
			return;
		}
	} while (tmp->next);
	tmp->next = newVal;			
}
